'--------------------------------------------------------------
'
' PROGRAM DISPLEJ-7LED-2a.bas  Ukzka olvdn dvoumstnho 7-segmentovho LED zobrazovae
'
' Program, kter pi kadm stisku tlatka Tl1 postupn zvyuje a na displeji
' zobrazuje slice od 0 po 99. Pklad multiplexnho zen displeje.
'--------------------------------------------------------------

$regfile = "m8adef.dat"                                      'nadefinoovn pouitho ipu
$crystal = 12000000                                         'nadefinovn internho krystalu z dvodu pesnosti

Config Portc.0 = Input                                      'nadefinovn vstup a vstup
Portc.0 = 1
Config Portd = Output

'aliasing
Tl1 Alias Pinc.0                                            'nadefinovn ltatka, jeliko je to vstupn tak mus bt PIN

Dim Cislo As Integer                                        'celoseln promnn "Cislo" typu integer (-32768 a + 32767)
Dim Cislo1 As Integer                                       'celoseln promnn "Cislo1" typu integer - pro jednotky
Dim Cislo10 As Integer                                      'celoseln promnn "Cislo10" typu integer - pro destky
Cislo = 0                                                   'vynulovn promnn "Cislo"

Portd = &B11111111                                          'posilani na cel port D hodnotu v binrnm kdu - zhasnut displeje

'-------------- HLAVNI PROGRAM -------------------------------
'nekonen smyka                                 

Do
   If Tl1 = 0 Then Cislo = Cislo + 1                        's kadm stiskem tlatka se promnn "Cislo" zv o 1

   Cislo1 = Cislo Mod 10                                    'vydl promnnou Cislo 10 a zbytek po dlen zapi do promnn Cislo1

   Gosub Jednotky                                           'sko na podprogram Jednotky a po jeho proveden se vrt do hl.programu

   Cislo10 = Cislo \ 10                                     'vydl promnnou Cislo 10 a vsledek zapi do promnn Cislo10

   Gosub Desitky                                            'sko na podprogram Destky a po jeho proveden se vrt do hl.programu

   If Cislo >= 100 Then Cislo = 0                           'je-li promnn Cislo rovna nebo vt ne 100, dojde k jejmu vynulovn

Loop
End
'--------- KONEC HLAVNIHO PROGRAMU ---------------------------

'-------------------- PODPROGRAMY ---------------------------

'Podprogram pro zobrazen jednotek

Jednotky:
   If Cislo1 = 0 Then                                       'kdy promnnn Cislo1 je njak hodnota, pak poli
   Portd = &B00010000                                       'na PortD hodnotu v BCD kdu a zapni zobrazova jednotek
   Elseif Cislo1 = 1 Then
   Portd = &B00010001
   Elseif Cislo1 = 2 Then
   Portd = &B00010010
   Elseif Cislo1 = 3 Then
   Portd = &B00010011
   Elseif Cislo1 = 4 Then
   Portd = &B00010100
   Elseif Cislo1 = 5 Then
   Portd = &B00010101
   Elseif Cislo1 = 6 Then
   Portd = &B00010110
   Elseif Cislo1 = 7 Then
   Portd = &B00010111
   Elseif Cislo1 = 8 Then
   Portd = &B00011000
   Elseif Cislo1 = 9 Then
   Portd = &B00011001
   End If
   Waitms 1
   Return                                                   'konec podprogramu a nvrat do hlavnho programu

   'Podprogram pro zobrazen jednotek

Desitky:
   If Cislo10 = 0 Then                                      'kdy promnnn Cislo10 je njak hodnota, pak poli
   Portd = &B00100000                                       'na PortD hodnotu v BCD kdu a zapni zobrazova destek
   Elseif Cislo10 = 1 Then
   Portd = &B00100001
   Elseif Cislo10 = 2 Then
   Portd = &B00100010
   Elseif Cislo10 = 3 Then
   Portd = &B00100011
   Elseif Cislo10 = 4 Then
   Portd = &B00100100
   Elseif Cislo10 = 5 Then
   Portd = &B00100101
   Elseif Cislo10 = 6 Then
   Portd = &B00100110
   Elseif Cislo10 = 7 Then
   Portd = &B00100111
   Elseif Cislo10 = 8 Then
   Portd = &B00101000
   Elseif Cislo10 = 9 Then
   Portd = &B00101001
   End If
   Waitms 1
   Return                                                   'konec podprogramu a nvrat do hlavnho programu